class SegTree:
    def __init__(self, nums):
        self.n = len(nums)
        self.tree = [0] * self.n + nums
        for i in reversed(range(1, self.n)):
            self.tree[i] = self.tree[i<<1] * self.tree[i<<1|1]
    
    def query(self, i, j, mod):
        i += self.n
        j += self.n
        res = 1
        while i <= j:
            if i & 1 == 1:
                res = (res * self.tree[i]) % mod
                i += 1
            i >>= 1
            if j & 1 == 0:
                res = (res * self.tree[j]) % mod
                j -= 1
            j >>= 1
        return res

import fileinput as fi
IN = fi.input()

def INT():
    return int(IN.readline())

def INTS():
    return tuple(int(num) for num in IN.readline().split())


N = INT()
nums = [int(num) for num in IN.readline().split()]
seg = SegTree(nums)
N = INT()
for _ in range(N):
    a, b, c = INTS()
    print("Yes" if seg.query(a-1, b-1, c) == 0 else "No")